Kerbal Space Program - Bug #14194

Navball doesn't follow the kerbal when on EVA
03/12/2017 06:43 PM - linuxgurugamer

Status: Closed Start date: 03/12/2017
Severity: Low % Done: 100%
Assignee:

Category: Gameplay

Target version:

Version: 1.2.2 Language: English (US)
Platform: Windows Mod Related: No
Expansion:

Description

This was a "feature” added back in 1.0.5: see the Navball section here:http://wiki.kerbalspaceprogram.com/wiki/1.0.5 .
I've fixed it in EVA Enhancements using the following code:

Transform target;

Vector3 rotationOffset = new Vector3(0f, 0f, 0f);

Quaternion attitudeGimbal;

CelestialBody currentMainBody;

static NavBall nav = FindObjectOfType&lt;KSP.UI.Screens.Flight.NavBall&gt; (); // cache som
ewhere

private void LateUpdate ()

{

if (!FlightGlobals.ActiveVessel.isEVA || !settings.evaNavballFollowsKerbal)
return;

currentMainBody = FlightGlobals.currentMainBody;

target = FlightGlobals.ActiveVessel.vesselTransform;

attitudeGimbal = Quaternion.Euler (rotationOffset) * Quaternion.Inverse (target.rotation);
nav.navBall.rotation = attitudeGimbal * Quaternion.LookRotation (Vector3.ProjectOnPlane (currentMain
Body.position + (currentMainBody.transform.up * (float)currentMainBody.Radius) - target.position,

(target.position - currentMainBody.position) .normalized) .normalized, (target.position - currentMai
nBody.position) .normalized) ;

And using EVA Enhancements, can now flip between modes.. But really, | don't understand why it was done this way.

History

#1 - 07/24/2019 02:56 PM - Robert.Keech
- Status changed from New to Updated
- % Done changed from 0 to 10

Issue no longer occurs

#2 - 07/24/2019 02:57 PM - Robert.Keech
- Status changed from Updated to Resolved
- % Done changed from 10 to 100

#3 - 07/24/2019 04:00 PM - chris.fulton

- Status changed from Resolved to Closed
